/* $XFree86: xc/programs/Xserver/hw/xfree86/ivtvhw/ivtvhw.h,v 1.11 2001/10/01 13:44:12 eich Exp $ */

#ifndef _FBDEVHW_H_
#define _FBDEVHW_H_

#include "xf86str.h"
#include "colormapst.h"
#include <asm/ioctl.h> 

#define FBDEVHW_PACKED_PIXELS		0	/* Packed Pixels	*/
#define FBDEVHW_PLANES			1	/* Non interleaved planes */
#define FBDEVHW_INTERLEAVED_PLANES	2	/* Interleaved planes	*/
#define FBDEVHW_TEXT			3	/* Text/attributes	*/
#define FBDEVHW_VGA_PLANES		4	/* EGA/VGA planes       */
#define IVTVFB_IOCTL_PREP_FRAME         _IOW('@', 3, struct ivtvfb_ioctl_dma_host_to_ivtv_args)
struct ivtvfb_ioctl_dma_host_to_ivtv_args {
        void* source;
        unsigned long dest_offset;
        int count;
};

Bool  ivtvHWGetRec(ScrnInfoPtr pScrn);
void  ivtvHWFreeRec(ScrnInfoPtr pScrn);

Bool  ivtvHWProbe(pciVideoPtr pPci, char *device, char **namep);
Bool  ivtvHWInit(ScrnInfoPtr pScrn, pciVideoPtr pPci, char *device);

char* ivtvHWGetName(ScrnInfoPtr pScrn);
int   ivtvHWGetDepth(ScrnInfoPtr pScrn, int *fbbpp);
int   ivtvHWGetLineLength(ScrnInfoPtr pScrn);
int   ivtvHWGetType(ScrnInfoPtr pScrn);
int   ivtvHWGetVidmem(ScrnInfoPtr pScrn);

/*void* ivtvHWMapVidmem(ScrnInfoPtr pScrn);*/
int   ivtvHWLinearOffset(ScrnInfoPtr pScrn);

void  ivtvHWSetVideoModes(ScrnInfoPtr pScrn);
DisplayModePtr ivtvHWGetBuildinMode(ScrnInfoPtr pScrn);
void  ivtvHWUseBuildinMode(ScrnInfoPtr pScrn);
Bool  ivtvHWModeInit(ScrnInfoPtr pScrn, DisplayModePtr mode);
void  ivtvHWSave(ScrnInfoPtr pScrn);
void  ivtvHWRestore(ScrnInfoPtr pScrn);

void  ivtvHWLoadPalette(ScrnInfoPtr pScrn, int numColors, int *indices,
		 LOCO *colors, VisualPtr pVisual);

int   ivtvHWValidMode(int scrnIndex, DisplayModePtr mode, Bool verbose, int flags);
Bool  ivtvHWSwitchMode(int scrnIndex, DisplayModePtr mode, int flags);
void  ivtvHWAdjustFrame(int scrnIndex, int x, int y, int flags);
Bool  ivtvHWEnterVT(int scrnIndex, int flags);
void  ivtvHWLeaveVT(int scrnIndex, int flags);
void  ivtvHWDPMSSet(ScrnInfoPtr pScrn, int mode, int flags);

Bool  ivtvHWSaveScreen(ScreenPtr pScreen, int mode);
Bool ivtvHWSendDMA(ScrnInfoPtr pScrn, void * ptr, int x1, int x2, int y1, int y2);

#endif
