/*
    Widescreen output mode demonstration utility
    Copyright (C) 2004  Hans Verkuil  <hverkuil@xs4all.nl>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>
#include <features.h> /* Uses _GNU_SOURCE to define getsubopt in stdlib.h */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <inttypes.h>
#include <getopt.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <math.h>
#include <linux/types.h>

#include "videodev2.h"

#include "ivtv.h"

int main(int argc, char **argv)
{
	char *device = "/dev/vbi8";
	struct ivtv_sliced_vbi_format fmt;
	char *buf;
	struct ivtv_sliced_data *p;
	int wss;
	int fh;

	if (argc <= 1) {
		fprintf(stderr, "usage: %s 0|1 [vbi device]\n", argv[0]);
	       	exit(1);
	}
	wss = 8 + (atol(argv[1]) ? 3 : 0);
	if (argc == 3) device = argv[2];
	fh = open(device, O_WRONLY);

	if (fh == -1) {
		fprintf(stderr, "cannot open %s\n", device);
		return 1;
	}

	fmt.service_set = IVTV_SLICED_WSS_625;
	if (ioctl(fh, IVTV_IOC_S_VBI_MODE, &fmt) == -1) {
		fprintf(stderr, "Set VBI mode failed\n");
		exit(1);
	}
	ioctl(fh, IVTV_IOC_G_VBI_MODE, &fmt);
	printf("%08lx, %ld, %ld\n", fmt.service_set, fmt.packet_size, fmt.io_size);
	buf = malloc(fmt.io_size);
	p = (struct ivtv_sliced_data *)buf;
	p->id = IVTV_SLICED_WSS_625;
	p->line = 23;
	p->data[0] = wss;
	p->data[1] = 0;
	write(fh, buf, fmt.packet_size);
	close(fh);
	return 0;
}

